﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

namespace Spread_BOM
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                #region 初始化

                // 设置当前页面 Spread 的初始状态
                DataTable dt = GetData();
                BOMCellType bom = new BOMCellType();
                List<BOM> items = BOM.BuildTree(dt);
                this.Session.Add("TreeInfo", items);
                bom.BOMItems = items;

                FpSpread1.ActiveSheetView.AllowPage = false;
                
                FpSpread1.ActiveSheetView.Columns[0].CellType = bom;
                FpSpread1.ActiveSheetView.DataAutoCellTypes = false;
                FpSpread1.ActiveSheetView.DataSource = GetData();

                FpSpread1.ActiveSheetView.ColumnHeader.Columns[0].Label = "编号";
                FpSpread1.ActiveSheetView.Columns[0].Locked = true;                
                FpSpread1.ActiveSheetView.Columns[0].Width = 300;
                FpSpread1.ActiveSheetView.Columns[4].Width = 200;
                FpSpread1.ActiveSheetView.Columns[1].Visible = false;
                FpSpread1.ActiveSheetView.Columns[2].Visible = false;
                FpSpread1.ActiveSheetView.Columns[3].Visible = false;
                FpSpread1.ActiveSheetView.Columns[9].Visible = false;

                #endregion
            }
            else
            {
                #region 处理节点点击事件

                if (Request.Params.AllKeys[0] == "fpcallback" && Request.Params["__EVENTTARGET"] == "FpSpread1")
                {
                    List<BOM> items = this.Session["TreeInfo"] as List<BOM>;

                    string arg = Request.Params["__EVENTARGUMENT"];
                    if (arg.IndexOf("NodeClickCommand") != -1)
                    {
                        int start = "NodeClickCommand%2C".Length;
                        int end = arg.IndexOf("%2C", start);

                        // 取到行号ID
                        int id = int.Parse(arg.Substring(start, end - start));

                        // 行的折叠/展开状态
                        end += "%2C".Length;
                        int expanded = int.Parse(arg.Substring(end));

                        foreach (BOM item in items)
                        {
                            if (item.ID == id)
                            {
                                // 修改点击行的折叠/展开状态
                                item.Expand = expanded;
                            }
                        }
                    }

                    BOMCellType bom = FpSpread1.ActiveSheetView.Columns[0].CellType as BOMCellType;
                    bom.BOMItems = items;
                    FpSpread1.ActiveSheetView.Columns[0].CellType = bom;
                }

                #endregion
            }
        }

        // 处理节点图标单机事件
        protected void FpSpread1_ButtonCommand(object sender, FarPoint.Web.Spread.SpreadCommandEventArgs e)
        {
            if (e.CommandName == "NodeClickCommand")
            {
                // 节点图片点击之后，修改其子节点所在行的显示状态
                System.Drawing.Point point = (System.Drawing.Point)e.CommandArgument;

                // 查询点击行的 BOM 信息
                List<BOM> items = this.Session["TreeInfo"] as List<BOM>;
                BOM currentrow = items.Where(s => s.ID == point.X).First();

                // 以当前点击的行作为根节点，遍历其所有子节点，并修改子节点所在行的显示状态
                ChangeRowState(items, currentrow, (currentrow.Expand == 1 ? true : false));
            }
        }

        // 修改行的显示状态
        private void ChangeRowState(List<BOM> items, BOM root, bool expanded)
        {
            var rows = items.Where(n => n.ParentID == root.ID);

            foreach (BOM row in rows)
            {
                ChangeRowState(items, row, expanded && (root.Expand == 0 ? false : true));
                FpSpread1.ActiveSheetView.Rows[row.RowNo].Visible = (expanded & (root.Expand == 0 ? false : true));
            }
        }

        // 获取数据源
        private DataTable GetData()
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("ParentID");
            dt.Columns.Add("编号");
            dt.Columns.Add("层级");
            dt.Columns.Add("名称");
            dt.Columns.Add("单价");
            dt.Columns.Add("数量");
            dt.Columns.Add("金额");
            dt.Columns.Add("备注");
            dt.Columns.Add("行号");

            dt.Rows.Add(0, -1, "JHW", 0, "西安葡萄城大厦", "", "", "", "", 0);
            dt.Rows.Add(1, 0, "001", 1, "A栋二楼201房主人房书柜", "", "", "", "", 1);
            dt.Rows.Add(2, 1, "01", 2, "外侧", "1920", "250", "330", "", 2);
            dt.Rows.Add(3, 1, "02", 2, "中侧", "1200", "345", "500", "", 3);
            dt.Rows.Add(4, 1, "03", 2, "底侧", "1200", "400", "500", "", 4);
            dt.Rows.Add(5, 4, "01", 3, "上底板", "1200", "350", "450", "", 5);
            dt.Rows.Add(6, 5, "01", 4, "18夹", "", "", "", "", 6);
            dt.Rows.Add(7, 5, "01", 4, "骨架", "", "", "", "", 7);
            dt.Rows.Add(8, 5, "01", 4, "12夹", "", "", "", "", 8);
            dt.Rows.Add(9, 4, "02", 3, "中底板", "1100", "360", "345", "", 9);
            dt.Rows.Add(10, 4, "03", 3, "下底板", "1200", "450", "450", "", 10);
            dt.Rows.Add(11, 10, "", 4, "18夹", "2300", "345", "", "", 11);
            dt.Rows.Add(12, 10, "", 4, "15夹", "1200", "678", "", "", 12);


            dt.Rows.Add(13, 0, "002", 1, "A栋十楼103房客房书柜", "", "", "", "", 13);
            dt.Rows.Add(14, 13, "01", 2, "外侧", "1920", "250", "330", "", 14);
            dt.Rows.Add(15, 13, "02", 2, "中侧", "1200", "345", "500", "", 15);
            dt.Rows.Add(16, 13, "03", 2, "底侧", "1200", "400", "500", "", 16);
            dt.Rows.Add(17, 16, "01", 3, "上底板", "1200", "350", "450", "", 17);
            dt.Rows.Add(18, 17, "01", 4, "18夹", "", "", "", "", 18);
            dt.Rows.Add(19, 17, "01", 4, "骨架", "", "", "", "", 19);
            dt.Rows.Add(20, 17, "01", 4, "12夹", "", "", "", "", 20);
            dt.Rows.Add(21, 16, "02", 3, "中底板", "1100", "360", "345", "", 21);
            dt.Rows.Add(22, 16, "03", 3, "下底板", "1200", "450", "450", "", 22);
            dt.Rows.Add(23, 22, "", 4, "18夹", "2300", "345", "", "", 23);
            dt.Rows.Add(24, 22, "", 4, "15夹", "1200", "678", "", "", 24);

            return dt;
        }

    }

    /// <summary>
    /// BOM 实体类型
    /// </summary>
    [Serializable]
    public class BOM
    {
        /// <summary>
        /// ID
        /// </summary>
        public int ID
        { get; set; }

        /// <summary>
        /// 上级ID
        /// </summary>
        public int ParentID
        { get; set; }

        /// <summary>
        /// 编号
        /// </summary>
        public string Code
        { get; set; }

        /// <summary>
        /// 层级
        /// </summary>
        public int Level
        { get; set; }

        // 行号
        public int RowNo
        { get; set; }

        /// <summary>
        /// 行的折叠/张开状态
        /// </summary>
        public int Expand
        { get; set; }


        public static List<BOM> BuildTree(DataTable data)
        {
            List<BOM> tree = new List<BOM>();
            foreach (DataRow row in data.Rows)
            {
                BOM item = new BOM();
                item.ID = int.Parse(row["ID"].ToString());
                item.ParentID = int.Parse(row["ParentID"].ToString());
                item.Code = row["编号"].ToString();
                item.Level = int.Parse(row["层级"].ToString());
                item.RowNo = int.Parse(row["行号"].ToString());
                item.Expand = 1;
                tree.Add(item);
            }
            return tree;
        }
    }

    /// <summary>
    /// BOM单元格类型
    /// </summary>
    [Serializable]
    public class BOMCellType : FarPoint.Web.Spread.GeneralCellType
    {
        /// <summary>
        /// 存放当前数据集中的 BOM 结构
        /// </summary>
        public List<BOM> BOMItems;

        public BOMCellType()
        {
            BOMItems = new List<BOM>();            
        }

        // 绘制 BOM 单元格的显示外观
        public override Control PaintCell(string id, TableCell parent, FarPoint.Web.Spread.Appearance style, FarPoint.Web.Spread.Inset margin, object value, bool upperLevel)
        {
            BOM item = BOMItems.Where(s => s.ID == int.Parse(value.ToString())).First<BOM>();

            Table table = new Table();
            TableRow row = new TableRow();

            // 节点缩进
            TableCell cell0 = new TableCell();
            cell0.Width = 50 * item.Level;

            // 节点图标
            TableCell cell1 = new TableCell();

            string url = GetImage(item);
            if (url != "")
            {
                // 当前节点有子节点，需要设置当前节点的显示图片
                cell0.Width = 50 * item.Level - (item.Level == 0 ? 0 : 16);
                System.Web.UI.WebControls.Image image = new System.Web.UI.WebControls.Image();
                image.ImageUrl = url;
                image.Attributes.Add("onclick", string.Format("NodeClick({0},{1})", item.ID, (item.Expand == 1 ? 0 : 1)));
                cell1.Controls.Add(image);
            }
            
            // 添加缩进
            row.Cells.Add(cell0);

            // 添加节点图片
            row.Cells.Add(cell1);

            // 节点文本
            TableCell cell2 = new TableCell();
            Label label = new Label();
            label.Text = item.Code;
            cell2.Controls.Add(label);
            row.Cells.Add(cell2);

            table.Rows.Add(row);

            return table;
        }

        // 返回节点图片地址
        private string GetImage(BOM item)
        {
            string url = "";

            var nodes = BOMItems.Where(s => s.ParentID == item.ID).Count();

            if (nodes > 0)
            {
                if (item.Expand == 1)
                    url = @"Icon\Expand.gif";
                else
                    url = @"Icon\Collapse.gif";
            }

            return url;
        }
    }
}